unit MainWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ExtCtrls, RXSpin, Buttons, RXShell, Menus,
  RxMenus;

type
  TMainFrm = class(TForm)
    Label2: TLabel;
    DirEd: TComboEdit;
    Bevel1: TBevel;
    TimerCheck: TCheckBox;
    Label3: TLabel;
    TimerEd: TRxSpinEdit;
    SaveBtn: TBitBtn;
    CanBtn: TBitBtn;
    TrayIcon: TRxTrayIcon;
    Timer: TTimer;
    Label5: TLabel;
    MaskEd: TEdit;
    Label6: TLabel;
    Bevel2: TBevel;
    Label1: TLabel;
    FormatCB: TComboBox;
    JpgLb1: TLabel;
    JpgQualEd: TRxSpinEdit;
    BmpLb: TLabel;
    BmpFmtCB: TComboBox;
    GifLb: TLabel;
    GifFmtCB: TComboBox;
    JpgLb2: TLabel;
    JpgFmtCB: TComboBox;
    Label4: TLabel;
    LastNumEd: TRxSpinEdit;
    RxPopupMenu1: TRxPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormatCBChange(Sender: TObject);
    procedure TimerCheckClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure TrayIconClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DirEdButtonClick(Sender: TObject);
    procedure CanBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure LoadSettings;
    procedure ScreenShot;
    function GetLastFileNum:integer;
    procedure WMSysCommand(var Msg : TWMSysCommand);message WM_SYSCOMMAND;
  public
  end;

var
  MainFrm: TMainFrm;

implementation
uses IniFiles,RxGIF,Jpeg,FileUtil;

{$R *.DFM}

const
  IniFName='ScreenShot.ini';
var
  Ini     :TIniFile;
  MyPath  :string;
  BmpImg  :TBitmap;
  GifImg  :TGifImage;
  JpgImg  :TJPEGImage;
  DeskCanv :TCanvas;

  Icon1Handle,Icon2Handle:THandle;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  MyPath:=ExtractFilePath(ParamStr(0));
  Ini:=TIniFile.Create(MyPath+IniFName);
  LoadSettings;

  BmpImg:=TBitmap.Create;
  GifImg:=TGifImage.Create;
  JpgImg:=TJPEGImage.Create;
  SaveBtnClick(Self);

  DeskCanv:=TCanvas.Create;
  DeskCanv.Handle:=GetDC(Hwnd_Desktop);

  Icon1Handle:=LoadIcon(hInstance,'WERT1');
  Icon2Handle:=LoadIcon(hInstance,'WERT2');

  TrayIcon.Icon.Handle:=Icon1Handle;

  LastNumEd.Value:=GetLastFileNum;
  Timer.Interval  :=TimerEd.AsInteger*1000;
  Timer.Enabled   :=TimerCheck.Checked;
end;

procedure TMainFrm.LoadSettings;
begin
  FormatCB.ItemIndex :=Ini.ReadInteger('Settings','ImgFormat',0);    {*}   FormatCBChange(Self);
  JpgQualEd.Value    :=Ini.ReadInteger('Settings','JpgQual',30);
  JpgFmtCB.ItemIndex :=Ini.ReadInteger('Settings','JpgFmt',0);
  GifFmtCB.ItemIndex :=Ini.ReadInteger('Settings','GifFmt',0);
  BmpFmtCB.ItemIndex :=Ini.ReadInteger('Settings','BmpFmt',0);
  DirEd.Text         :=Ini.ReadString('Settings','WorkDir',MyPath);
  TimerEd.Value      :=Ini.ReadInteger('Settings','Timer',5);
  TimerCheck.Checked :=Ini.ReadBool('Settings','TimerOk',false);     {*}   TimerCheckClick(Self);
  MaskEd.Text        :=Ini.ReadString('Settings','FileMask','img%.3d');
end;

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Ini.Free;
  BmpImg.Free;
  GifImg.Free;
  JpgImg.Free;
  DeskCanv.Free;
end;

procedure TMainFrm.FormatCBChange(Sender: TObject);
begin
  BmpLb.Enabled     :=(FormatCB.ItemIndex=0);
  BmpFmtCB.Enabled  :=BmpLb.Enabled;

  GifLb.Enabled     :=(FormatCB.ItemIndex=1);
  GifFmtCB.Enabled  :=GifLb.Enabled;

  JpgLb1.Enabled    :=(FormatCB.ItemIndex=2);
  JpgLb2.Enabled    :=JpgLb1.Enabled;
  JpgQualEd.Enabled :=JpgLb1.Enabled;
  JpgFmtCB.Enabled  :=JpgLb1.Enabled;
end;

procedure TMainFrm.TimerCheckClick(Sender: TObject);
begin
  Label3.Enabled  :=TimerCheck.Checked;
  TimerEd.Enabled :=TimerCheck.Checked;
end;

procedure TMainFrm.ScreenShot;
var
  FName:string;
begin
  TrayIcon.Icon.Handle:=Icon2Handle;


  if (BmpImg.Width<>Screen.Width)or(BmpImg.Height<>Screen.Height) then begin
    BmpImg.Width :=Screen.Width;
    BmpImg.Height:=Screen.Height;
  end;
  
  BmpImg.Canvas.CopyRect(BmpImg.Canvas.ClipRect,DeskCanv,DeskCanv.ClipRect);

  FName:=DirEd.Text+Format(MaskEd.Text,[LastNumEd.AsInteger]);

  case FormatCB.ItemIndex of
    0:BmpImg.SaveToFile(FName+'.bmp');
    1:begin
        if GifImg.Count=0 then GifImg.AddFrame(BmpImg)
        else GifImg.Frames[0].Assign(BmpImg);
        GifImg.SaveToFile(FName+'.gif'); 
      end;
    2:begin
        JpgImg.Assign(BmpImg);
        JpgImg.SaveToFile(FName+'.jpg')
      end;
  end;

  LastNumEd.Value:=LastNumEd.Value+1;

  TrayIcon.Icon.Handle:=Icon1Handle;
end;

procedure TMainFrm.SaveBtnClick(Sender: TObject);
begin
  case FormatCB.ItemIndex of
    0:case BmpFmtCB.ItemIndex of
        0:BmpImg.PixelFormat:=pf4bit;   // 16 
        1:BmpImg.PixelFormat:=pf8bit;   // 256 
        2:BmpImg.PixelFormat:=pf16bit;  // 16 
        3:BmpImg.PixelFormat:=pf24bit;  // 24 
        4:BmpImg.PixelFormat:=pf32bit;  // 32 
      end;
    1:case GifFmtCB.ItemIndex of
        0:BmpImg.PixelFormat:=pf4bit;   // 16 
        1:BmpImg.PixelFormat:=pf8bit;   // 256 
      end;
    2:case JpgFmtCB.ItemIndex of
        0:BmpImg.PixelFormat:=pf8bit;   // 16 
        1:BmpImg.PixelFormat:=pf24bit;  // 256 
      end;
  end;

  case JpgFmtCB.ItemIndex of
    0:JpgImg.PixelFormat:=jf8Bit;   // 8 
    1:JpgImg.PixelFormat:=jf24Bit;  // 24 
  end;

  JpgImg.CompressionQuality:=JpgQualEd.AsInteger;


  Ini.WriteInteger('Settings','ImgFormat',FormatCB.ItemIndex);
  Ini.WriteInteger('Settings','JpgQual',JpgQualEd.AsInteger);
  Ini.WriteInteger('Settings','JpgFmt',JpgFmtCB.ItemIndex);
  Ini.WriteInteger('Settings','GifFmt',GifFmtCB.ItemIndex);
  Ini.WriteInteger('Settings','BmpFmt',BmpFmtCB.ItemIndex);
  Ini.WriteString('Settings','WorkDir',DirEd.Text);
  Ini.WriteInteger('Settings','Timer',TimerEd.AsInteger);
  Ini.WriteBool('Settings','TimerOk',TimerCheck.Checked);
  Ini.WriteString('Settings','FileMask',MaskEd.Text);

  Timer.Interval  :=TimerEd.AsInteger*1000;
  Timer.Enabled   :=TimerCheck.Checked;

  Hide;
end;

function TMainFrm.GetLastFileNum: integer;
var
  TmpS:string;
  i:integer;
begin
  TmpS:=DirEd.Text+MaskEd.Text;
  case FormatCB.ItemIndex of
    0:TmpS:=TmpS+'.bmp';
    1:TmpS:=TmpS+'.gif';
    2:TmpS:=TmpS+'.jpg';
  end;

  i:=1;
  while FileExists(Format(TmpS,[i])) do inc(i);

  if FileExists(Format(TmpS,[i])) then Result:=i+1
  else Result:=i;
end;

procedure TMainFrm.WMSysCommand(var Msg: TWMSysCommand);
begin
  //     
  case Msg.CmdType of
    SC_MINIMIZE: Hide;        //     
    SC_CLOSE: if Application.MessageBox(' ?',
                 ' ?',MB_YESNO+MB_ICONQUESTION)=IDYES
              then inherited  //   
              else Hide;      //   
    else inherited;           //    (  )
  end;
end;

procedure TMainFrm.N1Click(Sender: TObject);
begin
  Show;
end;

procedure TMainFrm.N3Click(Sender: TObject);
begin
  Close;
end;

procedure TMainFrm.TrayIconClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then ScreenShot;
end;

procedure TMainFrm.DirEdButtonClick(Sender: TObject);
var
  TmpS:string;
begin
  TmpS:=Copy(DirEd.Text,1,Length(DirEd.Text)-1);
  if BrowseDirectory(TmpS,' ',0) then begin
    if TmpS[Length(TmpS)]<>'\' then TmpS:=TmpS+'\';
    DirEd.Text:=TmpS;
    LastNumEd.Value:=GetLastFileNum;
  end;
end;

procedure TMainFrm.CanBtnClick(Sender: TObject);
begin
  LoadSettings;
  Hide;
end;

procedure TMainFrm.TimerTimer(Sender: TObject);
begin
  ScreenShot;
end;

procedure TMainFrm.FormShow(Sender: TObject);
begin
  Timer.Enabled:=false;
end;

end.
